MAKEALL 14.2 KB
Newer Older
Peter Tyser's avatar
Peter Tyser committed
1
#!/bin/bash
2 3 4 5
# Tool mainly for U-Boot Quality Assurance: build one or more board
# configurations with minimal verbosity, showing only warnings and
# errors.

6 7 8 9 10 11 12 13 14 15 16 17 18
usage()
{
	# if exiting with 0, write to stdout, else write to stderr
	local ret=${1:-0}
	[ "${ret}" -eq 1 ] && exec 1>&2
	cat <<-EOF
	Usage: MAKEALL [options] [--] [boards-to-build]

	Options:
	  -a ARCH,   --arch ARCH       Build all boards with arch ARCH
	  -c CPU,    --cpu CPU         Build all boards with cpu CPU
	  -v VENDOR, --vendor VENDOR   Build all boards with vendor VENDOR
	  -s SOC,    --soc SOC         Build all boards with soc SOC
19
	  -l,        --list            List all targets to be built
20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50
	  -h,        --help            This help output

	Selections by these options are logically ANDed; if the same option
	is used repeatedly, such selections are ORed.  So "-v FOO -v BAR"
	will select all configurations where the vendor is either FOO or
	BAR.  Any additional arguments specified on the command line are
	always build additionally.  See the boards.cfg file for more info.

	If no boards are specified, then the default is "powerpc".

	Environment variables:
	  BUILD_NCPUS      number of parallel make jobs (default: auto)
	  CROSS_COMPILE    cross-compiler toolchain prefix (default: "")
	  MAKEALL_LOGDIR   output all logs to here (default: ./LOG/)
	  BUILD_DIR        output build directory (default: ./)

	Examples:
	  - build all Power Architecture boards:
	      MAKEALL -a powerpc
	      MAKEALL --arch powerpc
	      MAKEALL powerpc
	  - build all PowerPC boards manufactured by vendor "esd":
	      MAKEALL -a powerpc -v esd
	  - build all PowerPC boards manufactured either by "keymile" or "siemens":
	      MAKEALL -a powerpc -v keymile -v siemens
	  - build all Freescale boards with MPC83xx CPUs, plus all 4xx boards:
	      MAKEALL -c mpc83xx -v freescale 4xx
	EOF
	exit ${ret}
}

51 52
SHORT_OPTS="ha:c:v:s:l"
LONG_OPTS="help,arch:,cpu:,vendor:,soc:,list"
53 54 55

# Option processing based on util-linux-2.13/getopt-parse.bash

Wolfgang Denk's avatar
Wolfgang Denk committed
56
# Note that we use `"$@"' to let each command-line parameter expand to a
57 58 59 60 61 62
# separate word. The quotes around `$@' are essential!
# We need TEMP as the `eval set --' would nuke the return value of
# getopt.
TEMP=`getopt -o ${SHORT_OPTS} --long ${LONG_OPTS} \
     -n 'MAKEALL' -- "$@"`

63
[ $? != 0 ] && usage 1
64 65 66 67 68

# Note the quotes around `$TEMP': they are essential!
eval set -- "$TEMP"

SELECTED=''
69
ONLY_LIST=''
70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108

while true ; do
	case "$1" in
	-a|--arch)
		# echo "Option ARCH: argument \`$2'"
		if [ "$opt_a" ] ; then
			opt_a="${opt_a%)} || \$2 == \"$2\")"
		else
			opt_a="(\$2 == \"$2\")"
		fi
		SELECTED='y'
		shift 2 ;;
	-c|--cpu)
		# echo "Option CPU: argument \`$2'"
		if [ "$opt_c" ] ; then
			opt_c="${opt_c%)} || \$3 == \"$2\")"
		else
			opt_c="(\$3 == \"$2\")"
		fi
		SELECTED='y'
		shift 2 ;;
	-s|--soc)
		# echo "Option SoC: argument \`$2'"
		if [ "$opt_s" ] ; then
			opt_s="${opt_s%)} || \$6 == \"$2\")"
		else
			opt_s="(\$6 == \"$2\")"
		fi
		SELECTED='y'
		shift 2 ;;
	-v|--vendor)
		# echo "Option VENDOR: argument \`$2'"
		if [ "$opt_v" ] ; then
			opt_v="${opt_v%)} || \$5 == \"$2\")"
		else
			opt_v="(\$5 == \"$2\")"
		fi
		SELECTED='y'
		shift 2 ;;
109 110 111
	-l|--list)
		ONLY_LIST='y'
		shift ;;
112 113
	-h|--help)
		usage ;;
114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130
	--)
		shift ; break ;;
	*)
		echo "Internal error!" >&2 ; exit 1 ;;
	esac
done
# echo "Remaining arguments:"
# for arg do echo '--> '"\`$arg'" ; done

FILTER="\$1 !~ /^#/"
[ "$opt_a" ] && FILTER="${FILTER} && $opt_a"
[ "$opt_c" ] && FILTER="${FILTER} && $opt_c"
[ "$opt_s" ] && FILTER="${FILTER} && $opt_s"
[ "$opt_v" ] && FILTER="${FILTER} && $opt_v"

if [ "$SELECTED" ] ; then
	SELECTED=$(awk '('"$FILTER"') { print $1 }' boards.cfg)
131 132 133 134 135 136

	# Make sure some boards from boards.cfg are actually found
	if [ -z "$SELECTED" ] ; then
		echo "Error: No boards selected, invalid arguments"
		exit 1
	fi
137 138 139 140
fi

#########################################################################

Peter Tyser's avatar
Peter Tyser committed
141 142 143 144
# Print statistics when we exit
trap exit 1 2 3 15
trap print_stats 0

145 146 147 148 149
# Determine number of CPU cores if no default was set
: ${BUILD_NCPUS:="`getconf _NPROCESSORS_ONLN`"}

if [ "$BUILD_NCPUS" -gt 1 ]
then
Peter Tyser's avatar
Peter Tyser committed
150
	JOBS="-j $((BUILD_NCPUS + 1))"
151 152 153 154
else
	JOBS=""
fi

wdenk's avatar
wdenk committed
155

wdenk's avatar
wdenk committed
156 157 158 159 160 161
if [ "${CROSS_COMPILE}" ] ; then
	MAKE="make CROSS_COMPILE=${CROSS_COMPILE}"
else
	MAKE=make
fi

162 163 164 165 166
if [ "${MAKEALL_LOGDIR}" ] ; then
	LOG_DIR=${MAKEALL_LOGDIR}
else
	LOG_DIR="LOG"
fi
167

168 169 170 171
if [ ! "${BUILD_DIR}" ] ; then
	BUILD_DIR="."
fi

172
[ -d ${LOG_DIR} ] || mkdir ${LOG_DIR} || exit 1
wdenk's avatar
wdenk committed
173 174 175

LIST=""

Peter Tyser's avatar
Peter Tyser committed
176 177 178 179
# Keep track of the number of builds and errors
ERR_CNT=0
ERR_LIST=""
TOTAL_CNT=0
Peter Tyser's avatar
Peter Tyser committed
180
RC=0
Peter Tyser's avatar
Peter Tyser committed
181

182 183 184 185 186 187 188 189 190 191 192
# Helper funcs for parsing boards.cfg
boards_by_field()
{
	awk \
		-v field="$1" \
		-v select="$2" \
		'($1 !~ /^#/ && $field == select) { print $1 }' \
		boards.cfg
}
boards_by_arch() { boards_by_field 2 "$@" ; }
boards_by_cpu()  { boards_by_field 3 "$@" ; }
Andreas Bießmann's avatar
Andreas Bießmann committed
193
boards_by_soc()  { boards_by_field 6 "$@" ; }
194

195 196 197 198
#########################################################################
## MPC5xx Systems
#########################################################################

199
LIST_5xx="$(boards_by_cpu mpc5xx)"
200

201 202 203 204
#########################################################################
## MPC5xxx Systems
#########################################################################

205
LIST_5xxx="$(boards_by_cpu mpc5xxx)"
206

207 208 209 210
#########################################################################
## MPC512x Systems
#########################################################################

211
LIST_512x="$(boards_by_cpu mpc512x)"
212

wdenk's avatar
wdenk committed
213 214 215
#########################################################################
## MPC8xx Systems
#########################################################################
216

217
LIST_8xx="$(boards_by_cpu mpc8xx)"
wdenk's avatar
wdenk committed
218 219 220 221 222

#########################################################################
## PPC4xx Systems
#########################################################################

223
LIST_4xx="$(boards_by_cpu ppc4xx)"
wdenk's avatar
wdenk committed
224

wdenk's avatar
wdenk committed
225 226 227 228
#########################################################################
## MPC8220 Systems
#########################################################################

229
LIST_8220="$(boards_by_cpu mpc8220)"
wdenk's avatar
wdenk committed
230

wdenk's avatar
wdenk committed
231 232 233 234
#########################################################################
## MPC824x Systems
#########################################################################

235
LIST_824x="$(boards_by_cpu mpc824x)"
wdenk's avatar
wdenk committed
236

wdenk's avatar
wdenk committed
237
#########################################################################
wdenk's avatar
wdenk committed
238
## MPC8260 Systems (includes 8250, 8255 etc.)
wdenk's avatar
wdenk committed
239 240
#########################################################################

241
LIST_8260="$(boards_by_cpu mpc8260)"
wdenk's avatar
wdenk committed
242

Eran Liberty's avatar
Eran Liberty committed
243 244 245 246
#########################################################################
## MPC83xx Systems (includes 8349, etc.)
#########################################################################

247
LIST_83xx="$(boards_by_cpu mpc83xx)"
Eran Liberty's avatar
Eran Liberty committed
248

249 250 251 252
#########################################################################
## MPC85xx Systems (includes 8540, 8560 etc.)
#########################################################################

253
LIST_85xx="$(boards_by_cpu mpc85xx)"
254

255 256 257 258
#########################################################################
## MPC86xx Systems
#########################################################################

259
LIST_86xx="$(boards_by_cpu mpc86xx)"
260

wdenk's avatar
wdenk committed
261 262 263 264
#########################################################################
## 74xx/7xx Systems
#########################################################################

265
LIST_74xx_7xx="$(boards_by_cpu 74xx_7xx)"
wdenk's avatar
wdenk committed
266

Wolfgang Denk's avatar
Wolfgang Denk committed
267 268 269 270 271 272 273 274 275 276
#########################################################################
## PowerPC groups
#########################################################################

LIST_TSEC="		\
	${LIST_83xx}	\
	${LIST_85xx}	\
	${LIST_86xx}	\
"

Stefan Roese's avatar
Stefan Roese committed
277
LIST_powerpc="		\
278
	${LIST_5xx}	\
279
	${LIST_512x}	\
280 281 282 283 284 285 286 287 288
	${LIST_5xxx}	\
	${LIST_8xx}	\
	${LIST_8220}	\
	${LIST_824x}	\
	${LIST_8260}	\
	${LIST_83xx}	\
	${LIST_85xx}	\
	${LIST_86xx}	\
	${LIST_4xx}	\
289
	${LIST_74xx_7xx}\
290
"
wdenk's avatar
wdenk committed
291

Stefan Roese's avatar
Stefan Roese committed
292 293 294 295 296 297
# Alias "ppc" -> "powerpc" to not break compatibility with older scripts
# still using "ppc" instead of "powerpc"
LIST_ppc="		\
	${LIST_powerpc}	\
"

wdenk's avatar
wdenk committed
298 299 300 301
#########################################################################
## StrongARM Systems
#########################################################################

302
LIST_SA="$(boards_by_cpu sa1100)"
wdenk's avatar
wdenk committed
303 304 305 306 307

#########################################################################
## ARM9 Systems
#########################################################################

308 309 310
LIST_ARM9="$(boards_by_cpu arm920t)	\
	$(boards_by_cpu arm926ejs)	\
	$(boards_by_cpu arm925t)	\
311 312 313
	omap1610h2		\
	omap1610inn		\
	omap730p2		\
314
"
wdenk's avatar
wdenk committed
315

316 317 318
#########################################################################
## ARM11 Systems
#########################################################################
319
LIST_ARM11="$(boards_by_cpu arm1136)	\
320 321
	imx31_phycore		\
	imx31_phycore_eet	\
322
	mx31pdk			\
323
	smdk6400		\
324
"
325

326
#########################################################################
327
## ARMV7 Systems
328
#########################################################################
Dirk Behme's avatar
Dirk Behme committed
329 330

LIST_ARMV7="$(boards_by_cpu armv7)"
331

332 333 334 335
#########################################################################
## AT91 Systems
#########################################################################

336
LIST_at91="$(boards_by_soc at91)"
337

wdenk's avatar
wdenk committed
338 339 340 341
#########################################################################
## Xscale Systems
#########################################################################

342
LIST_pxa="$(boards_by_cpu pxa)"
wdenk's avatar
wdenk committed
343

344
LIST_ixp="$(boards_by_cpu ixp)
345 346 347
	pdnb3		\
	scpu		\
"
wdenk's avatar
wdenk committed
348

Wolfgang Denk's avatar
Wolfgang Denk committed
349 350 351
#########################################################################
## ARM groups
#########################################################################
352

353 354 355 356 357
LIST_arm="			\
	${LIST_SA}		\
	${LIST_ARM9}		\
	${LIST_ARM10}		\
	${LIST_ARM11}		\
358
	${LIST_ARMV7}	\
359 360 361
	${LIST_at91}		\
	${LIST_pxa}		\
	${LIST_ixp}		\
362
"
wdenk's avatar
wdenk committed
363

wdenk's avatar
wdenk committed
364
#########################################################################
365
## MIPS Systems		(default = big endian)
wdenk's avatar
wdenk committed
366 367
#########################################################################

368 369
LIST_mips4kc="		\
	incaip		\
370
	qemu_mips	\
371 372 373 374 375 376 377 378 379 380 381 382
	vct_platinum	\
	vct_platinum_small	\
	vct_platinum_onenand	\
	vct_platinum_onenand_small	\
	vct_platinumavc	\
	vct_platinumavc_small	\
	vct_platinumavc_onenand	\
	vct_platinumavc_onenand_small	\
	vct_premium	\
	vct_premium_small	\
	vct_premium_onenand	\
	vct_premium_onenand_small	\
383
"
wdenk's avatar
wdenk committed
384

385 386 387 388 389 390 391
LIST_au1xx0="		\
	dbau1000	\
	dbau1100	\
	dbau1500	\
	dbau1550	\
	gth2		\
"
wdenk's avatar
wdenk committed
392

393 394 395 396 397
LIST_mips="		\
	${LIST_mips4kc}	\
	${LIST_mips5kc}	\
	${LIST_au1xx0}	\
"
wdenk's avatar
wdenk committed
398

399 400 401 402
#########################################################################
## MIPS Systems		(little endian)
#########################################################################

403
LIST_xburst_el="	\
404 405
	qi_lb60		\
"
406

407 408
LIST_au1xx0_el="	\
	dbau1550_el	\
409
	pb1000		\
410 411
"
LIST_mips_el="			\
412
	${LIST_xburst_el}	\
413 414
	${LIST_au1xx0_el}	\
"
415

wdenk's avatar
wdenk committed
416
#########################################################################
Graeme Russ's avatar
Graeme Russ committed
417
## x86 Systems
wdenk's avatar
wdenk committed
418 419
#########################################################################

Graeme Russ's avatar
Graeme Russ committed
420
LIST_x86="$(boards_by_arch x86)"
wdenk's avatar
wdenk committed
421

wdenk's avatar
wdenk committed
422 423 424 425
#########################################################################
## Nios-II Systems
#########################################################################

426
LIST_nios2="$(boards_by_arch nios2)"
wdenk's avatar
wdenk committed
427

wdenk's avatar
wdenk committed
428 429 430 431
#########################################################################
## MicroBlaze Systems
#########################################################################

432
LIST_microblaze="$(boards_by_arch microblaze)"
wdenk's avatar
wdenk committed
433

434 435 436 437
#########################################################################
## ColdFire Systems
#########################################################################

438
LIST_m68k="$(boards_by_arch m68k)
439 440
	EB+MCF-EV123		\
	EB+MCF-EV123_internal	\
441
	M52277EVB		\
442
	M5235EVB		\
443
	M54451EVB		\
444
	M54455EVB		\
445
"
446
LIST_coldfire=${LIST_m68k}
447

448 449 450 451
#########################################################################
## AVR32 Systems
#########################################################################

452
LIST_avr32="$(boards_by_arch avr32)"
453

454 455 456 457
#########################################################################
## Blackfin Systems
#########################################################################

458
LIST_blackfin="$(boards_by_arch blackfin)"
459

460 461 462 463
#########################################################################
## SH Systems
#########################################################################

464
LIST_sh2="$(boards_by_cpu sh2)"
465
LIST_sh3="$(boards_by_cpu sh3)"
466
LIST_sh4="$(boards_by_cpu sh4)"
Wolfgang Denk's avatar
Wolfgang Denk committed
467

468
LIST_sh="$(boards_by_arch sh)"
469

470 471 472 473
#########################################################################
## SPARC Systems
#########################################################################

474
LIST_sparc="$(boards_by_arch sparc)"
wdenk's avatar
wdenk committed
475

476 477 478 479 480 481
#########################################################################
## NDS32 Systems
#########################################################################

LIST_nds32="$(boards_by_arch nds32)"

wdenk's avatar
wdenk committed
482 483 484 485 486
#-----------------------------------------------------------------------

build_target() {
	target=$1

487 488 489 490 491
	if [ "$ONLY_LIST" == 'y' ] ; then
		echo "$target"
		return
	fi

wdenk's avatar
wdenk committed
492
	${MAKE} distclean >/dev/null
493
	${MAKE} -s ${target}_config
494 495 496

	${MAKE} ${JOBS} all 2>&1 >${LOG_DIR}/$target.MAKELOG \
				| tee ${LOG_DIR}/$target.ERR
Peter Tyser's avatar
Peter Tyser committed
497 498 499 500 501 502

	# Check for 'make' errors
	if [ ${PIPESTATUS[0]} -ne 0 ] ; then
		RC=1
	fi

Peter Tyser's avatar
Peter Tyser committed
503 504 505 506 507 508 509 510
	if [ -s ${LOG_DIR}/$target.ERR ] ; then
		ERR_CNT=$((ERR_CNT + 1))
		ERR_LIST="${ERR_LIST} $target"
	else
		rm ${LOG_DIR}/$target.ERR
	fi

	TOTAL_CNT=$((TOTAL_CNT + 1))
511

512
	${CROSS_COMPILE}size ${BUILD_DIR}/u-boot \
513
				| tee -a ${LOG_DIR}/$target.MAKELOG
wdenk's avatar
wdenk committed
514
}
515 516 517 518 519 520 521 522 523 524 525 526 527 528 529 530
build_targets() {
	for t in "$@" ; do
		# If a LIST_xxx var exists, use it.  But avoid variable
		# expansion in the eval when a board name contains certain
		# characters that the shell interprets.
		case ${t} in
			*[-+=]*) list= ;;
			*)       list=$(eval echo '${LIST_'$t'}') ;;
		esac
		if [ -n "${list}" ] ; then
			build_targets ${list}
		else
			build_target ${t}
		fi
	done
}
wdenk's avatar
wdenk committed
531 532 533

#-----------------------------------------------------------------------

Peter Tyser's avatar
Peter Tyser committed
534
print_stats() {
535
	if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
Peter Tyser's avatar
Peter Tyser committed
536 537 538 539 540 541 542
	echo ""
	echo "--------------------- SUMMARY ----------------------------"
	echo "Boards compiled: ${TOTAL_CNT}"
	if [ ${ERR_CNT} -gt 0 ] ; then
		echo "Boards with warnings or errors: ${ERR_CNT} (${ERR_LIST} )"
	fi
	echo "----------------------------------------------------------"
Peter Tyser's avatar
Peter Tyser committed
543 544

	exit $RC
Peter Tyser's avatar
Peter Tyser committed
545
}
wdenk's avatar
wdenk committed
546

Peter Tyser's avatar
Peter Tyser committed
547
#-----------------------------------------------------------------------
548

549 550 551
# Build target groups selected by options, plus any command line args
set -- ${SELECTED} "$@"
# run PowerPC by default
552 553
[ $# = 0 ] && set -- powerpc
build_targets "$@"